% 371   02-10-2019

% Shell commands
pwd
ls
cd D:

%%   section     

%  !!!
help fft2
doc fft2

%%
%  (   )
a = 3.7
%     
a
% 
disp(a);

%     
%  ""    
%      
b = 1;

%    
whos

%    b
clear b

% %    a b c
clearvars a b c

%          
save myworkspacefilename.mat

%           
load myworkspacefilename.mat

%    
clear all

% Clear command prompt
clc

%         
5 + 3*2^3
(5 + 3)*2^3

% Vectors ()
% 
row = [1 2 6 4 exp(-1i*pi)];
%    
column = [1; 2; 6; 4; exp(-0.5*1i*pi)];
disp(column);
a = [3 7 3 4 1];
size(a)
length(a)
disp(a+row);
a = real(a);
row = real(row);
column = abs(column);
%    
a.*row 
%    
a*column
%    
column*row   

size(row)
size(column)
%    
row./a   
%%
ones(1,5)
zeros(1,5)
%%
% 
row./zeros(1,5)    
%  
isinf(row./zeros(1,5))   
isinf(row./a)
% Not a Number 
0/0
isnan(0/0)
%%
% 
a = [1 2; 3 4]
% 
a'  
%%
row = [1 exp(-1i*pi/5) exp(-2*1i*pi/5)]
% 
row'  
%   
row.'  
% 
conj(row)  
%  
j  
% 
i = 1
% 
b = a'  
c = a + b;
%    
a.*c   
%  
a*c    
%    
a*[1;1]  
%%
%   
d = [a [1;1]]   

%   ( )
r1 = 1:2:10   % _::_

%   
a1 = [ones(1,5); zeros(1,5); 1:5]

size(a1)
numel(a1)
%   
id  = eye(2)   
size(a)
size(c)
%    
a./c     
% 
inv(a)   
help inv
% 
det(a)   
%  
4^2      
%    
a.^2     
%      
a^2      
%    
a*a      
%  (     )
exp(a)   
%  (     )
log(a)
disp(row)
%  
real(row)  
%  
imag(row)  
% 
abs(row)   
% 
angle(row)  
angle(row)/pi
angle(1/0)
angle(i)
angle(1i)
%  
3i    
angle(-1)
angle(-1)/pi
%  
round(pi)    
round(0.5)
%   
floor(0.51)   
%   
ceil(0.51)  
%   
sum(row)     
%   
prod(row)   
%     (     )
sum(a,1)    
%     (     )
sum(a,2)    
%    
sum(a(:))   
%     (indexing)   1
row(0) %   !    
row(5) %   !
row(end) %  
row(end+1) %   !
row(end-1) %  
row(end-2) % ...     0     

r1 = 1:2:9
%    
linspace(1,9,5) 
%%
r = [2 4 7 5 8 1 9 6];
[mn, location] = min(r);
disp(location);


[mx, location] = max(r);
%%
%  
x = linspace(0,pi,101);
y = cos(x);
size(x)
size(y)
figure; %         
plot(x,y,'LineWidth',2)

figure;
stem(y)
%%
figure;
t=linspace(-pi,pi,201);
x = cos(t);
y = sin(t);
plot(x,y,'k','LineWidth',2);
axis equal
%%
figure;
x = 0:pi/100:2*pi;
y = sin(x);
plot(x,y)
xlabel('x')
ylabel('sin(x)')
title('Plot of the Sine Function')
%         (same figure window)
%         
plot(x,y,'r--')
%%
figure;
x = 0:pi/100:2*pi;
y = sin(x);
plot(x,y)
hold on %             
y2 = cos(x);
plot(x,y2,':')
legend('sin','cos')
%%
figure;
[X,Y] = meshgrid(-2:.2:2);
Z = X .* exp(-X.^2 - Y.^2);
surf(X,Y,Z)

figure;
t = 0:pi/10:2*pi;
[X,Y,Z] = cylinder(4*cos(t));
subplot(2,2,1); mesh(X); title('X');
subplot(2,2,2); mesh(Y); title('Y');
subplot(2,2,3); mesh(Z); title('Z');
subplot(2,2,4); mesh(X,Y,Z); title('X,Y,Z');
%%
h = 0.25 *[1 2 1]'*[1 2 1];
X = -0.5:0.01:0.5;
[m, ~] = size(h);
m1 = (m-1)/2;
X1 = 2.*pi*X;
U = ones(size(X,2),m);
for k = 1:m1
    U(:,k) = exp(1i*(m1-k+1)*X1);
    U(:,m+1-k) = conj(U(:,k));
end
Z = abs(U*h*U');
figure;surface(X,X,Z);
%%
h = ones(5,1)*ones(1,5);
[m, ~] = size(h);
m1 = (m-1)/2;
X1 = 2.*pi*X;
U = ones(size(X,2),m);
for k = 1:m1
    U(:,k) = exp(1i*(m1-k+1)*X1);
    U(:,m+1-k) = conj(U(:,k));
end
Z = abs(U*h*U');
figure;surface(X,X,Z);
%%
% Text
myText = 'Hello, world';
whos myText
otherText = 'You''re right'
longText = [myText,' - ',otherText]
f = 71;
c = (f-32)/1.8;
tempText = ['Temperature is ',num2str(c),'C']
%%
% Loops (  continue  break)
n = 10;
f = n;
while n > 1
    n = n-1;
    f = f*n;
end
disp(['n! = ' num2str(f)])
%%
nsamples = 5;
npoints = 50;
for k = 1:nsamples
 currentData = rand(npoints,1);
 sampleMean(k) = mean(currentData);
end
overallMean = mean(sampleMean)
%%
for k = 1:nsamples
 iterationString = ['Iteration #',int2str(k)];
 disp(iterationString)
 currentData = rand(npoints,1);
 sampleMean(k) = mean(currentData)
end
overallMean = mean(sampleMean)
%%
% Conditions
if overallMean < .49
 disp('Mean is less than expected')
elseif overallMean > .51
 disp('Mean is greater than expected')
else
 disp('Mean is within the expected range')
end
%%
n = input('Enter a number: ');
switch n
    case -1
        disp('negative one')
    case 0
        disp('zero')
    case 1
        disp('positive one')
    otherwise
        disp('other value')
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% MATLAB is terribly slow with for loops %
% use vectorized operations !!!          %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
% Numbers represented in the double format have a maximum precision of 52 bits. Any
% double requiring more bits than 52 loses some precision. For example, the following code
% shows two unequal values to be equal because they are both truncated:
x = 36028797018963968;
y = 36028797018963972;
x == y

% Integers have available precisions of 8-bit, 16-bit, 32-bit, and 64-bit. Storing the same
% numbers as 64-bit integers preserves precision:
x = uint64(36028797018963968);
y = uint64(36028797018963972);
x == y
%%
format short % default
x = [4/3 1.2345e-6]
format short e
x = [4/3 1.2345e-6]
format short g
x = [4/3 1.2345e-6]
format long
x = [4/3 1.2345e-6]
format long e
x = [4/3 1.2345e-6]
format long g
x = [4/3 1.2345e-6]
format bank
x = [4/3 1.2345e-6]
format rat
x = [4/3 1.2345e-6]
format hex
x = [4/3 1.2345e-6]

format compact % suppresses many of the blank lines that appear in the output

%%
%  
close all
clear all
A = imread('barbara.png');
disp(class(A));
figure; imshow(A);
figure; imshow(A,[],'Border','Tight');
figure; imshow(A,[50,200],'Border','Tight'); % IMPORTANT: [] in imshow
[info] = imfinfo('barbara.png');
struct(info)
disp([[info.Width] [info.Height]]);
disp([[info.XResolution] [info.YResolution]]);
disp([info.ResolutionUnit]);
%%
doc imresize

disp(mean2(A));
F = fft2(A);
B = ifft2(F,'symmetric');
figure; imshow(B,[],'Border','Tight');
disp(mean2(abs(double(A)-B)));
clear B;
Fmag = log(abs(fftshift(F)));
disp(max(Fmag(:)));
figure;
imshow(Fmag,[0 16],'Border','Tight'); colormap(jet);

%%
[img, map] = imread('barbara.png');
size(map)
img(1:15, :) = 1;
img(565:580, :) = 1;
img(:, 1:15) = 1;
img(:, 705:720) = 1;
figure; imshow(img, map);
img(580/2-20:580/2+20, 720/2-20:720/2+20) = 256; % why 256 ? --> indexed color map, matlab starts from 1
figure; imshow(img, map);

%%
lenna = imread('lenna.tiff');
whos
lenna;
size(lenna);
[row, col] = size(lenna);
figure; imshow(lenna);
lenna_red = lenna;
lenna_red(:,:,2:3) = 0;
figure; imshow(lenna_red);
lenna_green = lenna;
lenna_green(:,:,1) = 0;
lenna_green(:,:,3) = 0;
figure; imshow(lenna_green);
lenna_blue = lenna;
lenna_blue(:,:,1:2) = 0;
figure; imshow(lenna_blue);
lenna_yellow = lenna;
lenna_yellow(:,:,3) = 0;
figure; imshow(lenna_yellow);
imwrite(lenna_yellow, 'ly.tiff')

%%
plotrand %   (script)     plotrand.m

plotrand_w_arg(5) %       plotrand_w_arg.m

%%
% !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
%         
a = 5; % double
b = uint8(a); % unsigned integer (8 bits)
c = 9; % double
d = uint8(c); % unsigned integer (8 bits)
a - c %      -4
b - d  %      0 !!! 
	   %         

